hdu 1081 To The Max(dp+化二维为一维)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1081

To The Max

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 8839    Accepted Submission(s):
4281

Problem Description

Given a two-dimensional array of positive and negative
integers, a sub-rectangle is any contiguous sub-array of size 1 x 1 or greater
located within the whole array. The sum of a rectangle is the sum of all the
elements in that rectangle. In this problem the sub-rectangle with the largest
sum is referred to as the maximal sub-rectangle.

As an example, the
maximal sub-rectangle of the array:

0 -2 -7 0
9 2 -6 2
-4 1 -4
1
-1 8 0 -2

is in the lower left corner:

9 2
-4 1
-1
8

and has a sum of 15.

Input

The input consists of an N x N array of integers. The
input begins with a single positive integer N on a line by itself, indicating
the size of the square two-dimensional array. This is followed by N 2 integers
separated by whitespace (spaces and newlines). These are the N 2 integers of the
array, presented in row-major order. That is, all numbers in the first row, left
to right, then all numbers in the second row, left to right, etc. N may be as
large as 100. The numbers in the array will be in the range
[-127,127].

Output

Output the sum of the maximal sub-rectangle.

Sample Input

4

0 -2 -7 0 9 2 -6 2

-4 1 -4 1 -1

8 0 -2

Sample Output

15

题目大意:在一个数的矩阵里面找一个和最大矩阵。

题目思路:化二维为一维,转化成1003即可。先求一列一列的和,这样就转化成了一维了。举个例子,我先计算第一行得到dp[0]=0dp[1]=-2,dp[2]=-7,dp[3]=0;这些就是所谓的和,然后在用1003的方法做。那么第二行,就会更新,dp[0]=9,dp[1]=0,dp[2]=-13,dp[3]=2;这些依旧是和,这也就是转换成了一维数组,用1003的方法解决,以此类推~~~

详见代码。

 1 #include <iostream>
 2 #include <cstdio>
 3 #include <cstring>
 4
 5 using namespace std;
 6
 7 int dp[110];
 8 int num[110][110];
 9
10 int main ()
11 {
12     int n;
13     while (~scanf("%d",&n))
14     {
15         for (int i=0; i<n; i++)
16             for (int j=0; j<n; j++)
17                 scanf("%d",&num[i][j]);
18         int ans=-99999;
19         for (int i=0; i<n; i++)
20         {
21             memset(dp,0,sizeof(dp));
22             for (int j=i; j<n; j++)
23             {
24                 int Max=-1;
25                 for (int k=0; k<n; k++)
26                 {
27                     dp[k]+=num[j][k];       //先计算出所有的dp和
28                 }
29                 for (int k=0; k<n; k++)     //1003的做法,代码类似
30                 {
31                     if (Max+dp[k]<dp[k])
32                         Max=dp[k];
33                     else
34                         Max=Max+dp[k];
35                     if (ans<Max)              //不断更新最大值
36                     {
37                         ans=Max;
38                         //cout<<j<<" "<<k<<endl;
39                     }
40                 }
41             }
42         }
43         printf ("%d\n",ans);
44     }
45     return 0;
46 }
时间: 2024-11-07 22:30:34

hdu 1081 To The Max(dp+化二维为一维)的相关文章

HDU 1081 To The Max(DP)

题意  求一个n*n矩阵的最大子矩阵和 HDU 1003 max sum 的升级版   把二维简化为一维就可以用1003的方法去做了  用mat[i][j]存  第i行前j个数的和   那么mat[k][j]-mat[k][i]就表示第k行  第i+1个数到第j个数的和了   再将k从一枚举到n就可以得到这个这个宽度为j-i的最大矩阵和了   然后i,j又分别从1枚举到n就能得到结果了   和1003的方法一样  只是多了两层循环 #include<cstdio> #include<cs

HDU 1081 to the max 基础DP 好题

To The Max Problem Description Given a two-dimensional array of positive and negative integers, a sub-rectangle is any contiguous sub-array of size 1 x 1 or greater located within the whole array. The sum of a rectangle is the sum of all the elements

Max Sum Plus Plus HDU - 1024 基础dp 二维变一维的过程,有点难想

/* dp[i][j]=max(dp[i][j-1]+a[j],max(dp[i-1][k])+a[j]) (0<k<j) dp[i][j-1]+a[j]表示的是前j-1分成i组,第j个必须放在前一组里面. max( dp[i-1][k] ) + a[j] )表示的前(0<k<j)分成i-1组,第j个单独分成一组. */ #include <iostream> #include <cstdio> #include <cstring> #inclu

HDU 1081 To the Max 最大子矩阵(动态规划求最大连续子序列和)

Description Given a two-dimensional array of positive and negative integers, a sub-rectangle is any contiguous sub-array of size 1*1 or greater located within the whole array. The sum of a rectangle is the sum of all the elements in that rectangle. I

HDU 1081 To The Max 暴力模拟O(n^4) dp优化O(n^3)

原题: http://acm.hdu.edu.cn/showproblem.php?pid=1081 题目大意: 求给定边长的正方形选一个矩形,使它包含的所有元素的值最大. 大家都知道(a+b)^2的展开式,这里的优化就是用了这个原理来做的优化,我们的dp值是我们前i行j列的矩形区域的值. 任意矩形区域的值通过该展开式也能求解,所以我们可以暴力枚举每种以左上角(k,l)到右下角(i,j)的情况. 对于这个题边长是100,4层循环是10^8,因为循环并跑不了这么多,刚好也能卡过去. 代码如下: #

hdu 1081 To The Max(最大连续子序列推广到二维)

#include<cstdio> #include<cstring> #include<algorithm> using namespace std; const int INF=1<<30; int a[105][105]; int b[105]; int dp[105]; int maxx,ans; int main() { int n; while(scanf("%d",&n)==1) { for(int i=1;i<

HDU 1081 To The Max

题目链接 Problem Description Given a two-dimensional array of positive and negative integers, a sub-rectangle is any contiguous sub-array of size 1 x 1 or greater located within the whole array. The sum of a rectangle is the sum of all the elements in th

hdu 1081 To The Max 【最大子矩阵和】

To The Max Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 8882 Accepted Submission(s): 4288 Problem Description Given a two-dimensional array of positive and negative integers, a sub-rectangle is

hdu 1081最大子矩阵的和DP

To The Max Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 8210    Accepted Submission(s): 3991 Problem Description Given a two-dimensional array of positive and negative integers, a sub-rectan